#!/usr/bin/perl
%logs=(
#    "$ENV{'HOME'}/tmp/+abmail/from-log-20070215.bak",
#    "$ENV{'HOME'}/tmp/+abmail/from-log-2007021501.bak",
#    "$ENV{'HOME'}/tmp/+abmail/from-log-20070301",
    "$ENV{'HOME'}/tmp/+abmail/from-log-2007030101",
#    "$ENV{'HOME'}/tmp/+abmail/from-log-20061102", "$ENV{'HOME'}/tmp/+abmail/from-log-20070301",
);
%mon = (
    'Jan'=>1, 'Feb'=>2, 'Mar'=>3, 'Apr'=>4, 'May'=>5, 'Jun'=>6, 'Jul'=>7, 'Aug'=>8, 'Sep'=>9, 'Oct'=>10, 'Nov'=>11, 'Dec'=>12,
);
@pattern = split('\n', qx!sed -ne 's/.*this_is_abmail("\\(.*\\)").*/\\1/p' ../abmail.c | sort | uniq!);
%c = undef;
$m = undef;
sub init {
    $tc = 0;
    $vc = 0;
    $sc = 0;
    for $pattern (@pattern) {
	$c{"$pattern"} = 0;
    }
    $lines = undef;
}
init();
for $log (%logs) { open(LOG, "<$log"); while ($line=<LOG>) {
    if ($line =~ /^(abmail: |From |\(antivirus\)From )/) {
	$tc++;
	$vc++ if ($lines =~ /^\(antivirus\)From /);
	$sc++ if ($lines =~ /^abmail: /);
	for $pattern (@pattern) {
	    $c{"$pattern"}++ if ($lines =~ /^abmail: $pattern[\n;]/);
	}
	$lines = $line;	
    }
    else {
	$lines .= $line;
    }
} close(LOG); }
sub print_statics {
    ($t) = @_;
    if ($t eq '**/**/**') {
	for $p (("$t", "total", "virus", "spam", "normal", @pattern)) {
	    printf("%s,", $p);
	}
	print "\n";
    }
    printf("$t,%d,%d,%d,%d,", $tc,$vc,$sc,$tc-($vc+$sc));
    for $pattern (@pattern) {
	printf("%d,", $c{"$pattern"});
    }
    print "\n";
}
print_statics('**/**/**');

init();
for $log (%logs) { open(LOG, "<$log"); while ($line=<LOG>) {
    if ($line =~ /^(abmail: |From |\(antivirus\)From )/) {
	$tc++;
	$vc++ if ($lines =~ /^\(antivirus\)From /);
	$sc++ if ($lines =~ /^abmail: /);
	for $pattern (@pattern) {
	    $c{"$pattern"}++ if ($lines =~ /^abmail: $pattern[\n;]/);
	}
	if ($lines =~ /From .*  ... (...)\s+(\d+) \d\d:\d\d:\d\d (\d\d\d\d)\n/) {
	    $match = sprintf("%04d/%02d/%02d", $3, $mon{"$1"}, $2);
	    $m = $match unless ($m);
	    if ($m ne $match) {
		print_statics($m);
		$m = $match;
		init();
	    }
	}
	$lines = $line;	
    }
    else {
	$lines .= $line;
    }
} close(LOG); }
print_statics($match);
